// Ex-p5-Image10-Mask
// Pour p5.js
// 16-11-2016
// 
// Utilise: libraries/p5.js
// https://p5js.org/examples/image-create-image.html
// https://p5js.org/reference/#/p5/constrain
// https://p5js.org/reference/#/p5/dist

var TailleMasque = 15; // 1 .. 100
var image1, Masque;

function preload() {
  image1 = loadImage("IMG_8583-1024x768.jpg");
}

function setup() {
  createCanvas(1024, 768);
  // Creation d'un Masque
  Masque = createImage(2 * width, 2 * height);
  for (var x = 0; x <= Masque.width; x++) {
    for (var y = 0; y <= Masque.height; y++) {
      var a = map(dist(x, y, Masque.width / 2, Masque.height / 2), 0, Masque.height * TailleMasque / 100, 0, 255);
      Masque.set(x, y, [0, 0, 0, a]);
    }
  }
  Masque.updatePixels();
  imageMode(CENTER);
}

function draw() {
  image(image1, width / 2, height / 2);
  image(Masque, constrain(mouseX, 0, width), constrain(mouseY, 0, height));
}